<?php

use app\services\imap\Imap;
use app\services\imap\ConnectionErrorException;
use Ddeboer\Imap\Exception\MailboxDoesNotExistException;

defined('BASEPATH') or exit('No direct script access allowed');

class Devices extends AdminController
{
    public function __construct()
    {
        parent::__construct();
        $this->load->model('devices_model');
        $this->load->model('clients_model');

        if (!is_admin()) {
            access_denied('Devices');
        }
    }

    /* List all devices */
    public function index()
    {
        if ($this->input->is_ajax_request()) {
            $this->app->get_table_data('devices');
        }
        //$data['email_exist_as_staff'] = $this->email_exist_as_staff();
         $data['regions'] = $this->clients_model->get_regions();
        $data['zones'] = $this->clients_model->get_zones();
        $data['divisions'] = $this->clients_model->get_divisions();
        $data['police_stations'] = $this->clients_model->get_police_stations();
        $data['title']                = 'devices';
        $this->load->view('admin/devices/manage', $data);
    }
    
       public function device_report()
    {
        
        if ($this->input->post()) {
            $data['regions'] = $this->clients_model->get_regions();
            $data['zones'] = $this->clients_model->get_zones();
            $data['divisions'] = $this->clients_model->get_divisions();
            $data['police_stations'] = $this->clients_model->get_police_stations();
            $regionid = $this->input->post('regionid');
            $zoneid = $this->input->post('zoneid');
            $divisionid = $this->input->post('divisionid');
            $police_station_name = $this->input->post('police_station_name');
            $group_name = $this->input->post('group_name');
            $from_date = $this->input->post('from_date');
            $to_date = $this->input->post('to_date');
            $data['devices'] = $this->devices_model->get_device_report_filter($regionid , $zoneid ,$divisionid , $police_station_name, $group_name,$from_date,$to_date);
            //  var_dump($data['devices']);
            //  die();
            $data['title']                = 'devices';
            $this->load->view('admin/devices/device_report', $data);
            
        }else{
        $data['regions'] = $this->clients_model->get_regions();
        $data['zones'] = $this->clients_model->get_zones();
        $data['divisions'] = $this->clients_model->get_divisions();
        $data['police_stations'] = $this->clients_model->get_police_stations();
        //$data['email_exist_as_staff'] = $this->email_exist_as_staff();
         $data['devices'] = $this->devices_model->get_device_report();
        //  var_dump($data['devices']);
        //  die();
        // $data['zones'] = $this->clients_model->get_zones();
        // $data['divisions'] = $this->clients_model->get_divisions();
        // $data['police_stations'] = $this->clients_model->get_police_stations();
        $data['title']                = 'devices';
        $this->load->view('admin/devices/device_report', $data);
        }
    }

    /* Edit or add new device */
    public function device($id = '')
    {
        if ($this->input->post()) {
            $message          = '';
            $data             = $this->input->post();
            $data             = $this->input->post();
            //$data['password'] = $this->input->post('password', false);

            // if (isset($data['fakeusernameremembered']) || isset($data['fakepasswordremembered'])) {
            //     unset($data['fakeusernameremembered']);
            //     unset($data['fakepasswordremembered']);
            // }

            if (!$this->input->post('id')) {
                $id = $this->devices_model->add($data);
                if ($id) {
                    $success = true;
                    $message = _l('added_successfully', 'device');
                }
                echo json_encode([
                    'success'              => $success,
                    'message'              => $message,
                    //'email_exist_as_staff' => $this->email_exist_as_staff(),
                ]);
            } else {
                $id = $data['id'];
                unset($data['id']);
                $success = $this->devices_model->update($data, $id);
                if ($success) {
                    $message = _l('updated_successfully', _l('device'));
                }
                echo json_encode([
                    'success'              => $success,
                    'message'              => $message,
                    //'email_exist_as_staff' => $this->email_exist_as_staff(),
                ]);
            }
            die;
        }
    }

    /* Delete device from database */
    public function delete($id)
    {
        if (!$id) {
            redirect(admin_url('devices'));
        }
        $response = $this->devices_model->delete($id);
        if (is_array($response) && isset($response['referenced'])) {
            set_alert('warning', _l('is_referenced', _l('device_lowercase')));
        } elseif ($response == true) {
            set_alert('success', _l('deleted', _l('device')));
        } else {
            set_alert('warning', _l('problem_deleting', _l('device_lowercase')));
        }
        redirect(admin_url('devices'));
    }

    public function email_exists()
    {
        // First we need to check if the email is the same
        $deviceid = $this->input->post('deviceid');
        if ($deviceid) {
            $this->db->where('deviceid', $deviceid);
            $_current_email = $this->db->get(db_prefix() . 'devices')->row();
            if ($_current_email->email == $this->input->post('email')) {
                echo json_encode(true);
                die();
            }
        }
        $exists = total_rows(db_prefix() . 'devices', [
            'email' => $this->input->post('email'),
        ]);
        if ($exists > 0) {
            echo 'false';
        } else {
            echo 'true';
        }
    }

    public function folders()
    {
        app_check_imap_open_function();

        $imap = new Imap(
           $this->input->post('username') ? $this->input->post('username') : $this->input->post('email'),
           $this->input->post('password', false),
           $this->input->post('host'),
           $this->input->post('encryption')
        );

        try {
            echo json_encode($imap->getSelectableFolders());
        } catch (ConnectionErrorException $e) {
            echo json_encode([
                'alert_type' => 'warning',
                'message'    => $e->getMessage(),
            ]);
        }
    }

    public function test_imap_connection()
    {
        app_check_imap_open_function();

        $imap = new Imap(
           $this->input->post('username') ? $this->input->post('username') : $this->input->post('email'),
           $this->input->post('password', false),
           $this->input->post('host'),
           $this->input->post('encryption')
        );

        try {
            $connection = $imap->testConnection();

            try {
                $folder = $this->input->post('folder');

                $connection->getMailbox(empty($folder) ? 'INBOX' : $folder);
            } catch (MailboxDoesNotExistException $e) {
                echo json_encode([
                    'alert_type' => 'warning',
                    'message'    => $e->getMessage(),
                ]);
                die;
            }
            echo json_encode([
                'alert_type' => 'success',
                'message'    => _l('lead_email_connection_ok'),
            ]);
        } catch (ConnectionErrorException $e) {
            echo json_encode([
                'alert_type' => 'warning',
                'message'    => $e->getMessage(),
            ]);
        }
    }

    private function email_exist_as_staff()
    {
        return total_rows(db_prefix() . 'devices', 'email IN (SELECT email FROM ' . db_prefix() . 'staff)') > 0;
    }
}
